<?php
/*
Plugin Name: MWP Assets
Plugin URI: https://mwordpress.net/
Description: Theme Mobile Updater & Photon Experiments & Disable Jetpack Shortcodes Embeds
Author: Mouad Achemli
Version: 1.0
Author URI: http://mwordpress.net/
*/
add_filter( 'jetpack_get_available_modules', 'jetpack_docs_filter_module_shortcodes' );
function jetpack_docs_filter_module_shortcodes( $modules ) {
	if( isset( $modules['shortcodes'] ) ) {
		unset( $modules['shortcodes'] );
	}
	return $modules;
}
function mwp_deactivate_jetpack_shortcodes () {
	Jetpack::deactivate_module('shortcodes');
}
add_action('after_setup_theme','mwp_deactivate_jetpack_shortcodes');

/**
 * Photon Experiments
 * Change Photon image quality
 * 
*/
if ( class_exists( 'Jetpack' ) && Jetpack::is_module_active( 'photon' ) ) :
	function photon_experiments() {
		if (function_exists('mwp_option')) {
			add_filter( 'jetpack_photon_post_image_args', 'photon_experiments_quality', 100, 2 );
			add_filter( 'jetpack_images_get_images', 'mwp_jetpack_default_image', 10, 3 );
			if (mwp_option('thumbnail-type') == 8) :
				add_filter( 'jetpack_photon_url', 'jetpack_photon_url', 15, 3 );
			endif;
		}
	}
	add_action( 'plugins_loaded', 'photon_experiments', 20 );
	function photon_experiments_quality( $args, $image ) {
		$get_quality = mwp_option('thumbnail-quality');	
		if (!empty($get_quality)) {
			$quality = $get_quality;	
		} else {
			$quality = 80;
		}
		$args['quality'] = $quality;
		return $args;
	}
	function mwp_jetpack_default_image( $media, $post_id, $args ) {
		if ( $media ) {
			return $media;
		} else {
			$permalink = get_permalink( $post_id );
			$url = apply_filters( 'jetpack_photon_url', mwp_option('thumbnail-default') );
			return array( array(
				'type'  => 'image',
				'from'  => 'custom_fallback',
				'src'   => esc_url( $url ),
				'href'  => $permalink,
			) );
		}
	}
endif;

/*
 * Auto Updater Lightmag Mobole
 *
*/
define( 'MWP_MOBILE_THEME_UPDATER', 'http://store.mwordpress.net/api-1/');
define( 'MWP_MOBILE_THEME_BASE_LM', 'lightmag-mobile');

$get_theme = wp_get_theme( MWP_MOBILE_THEME_BASE_LM );
$theme_version = $get_theme->get( 'Version' );

function mwp_mobile_check_for_update_lm($checked_data) {
	
	global $wp_version, $theme_version;
	$theme_base = MWP_MOBILE_THEME_BASE_LM;
	
	$request = array(
		'slug' => MWP_MOBILE_THEME_BASE_LM,
		'version' => $theme_version 
	);

	$send_for_check = array(
		'body' => array(
			'action' => 'theme_update', 
			'request' => serialize($request),
			'api-key' => md5(get_bloginfo('url'))
		),
		'user-agent' => 'WordPress/' . $wp_version . '; ' . get_bloginfo('url')
	);
	$raw_response = wp_remote_post(MWP_MOBILE_THEME_UPDATER, $send_for_check);
	if (!is_wp_error($raw_response) && ($raw_response['response']['code'] == 200))
		$response = unserialize($raw_response['body']);

	if (!empty($response)) 
		$checked_data->response[$theme_base] = $response;

	return $checked_data;
	
}

function mwp_mobile_auto_update_call_lm($def, $action, $args) {
	
	global $theme_version;
	$theme_base = MWP_MOBILE_THEME_BASE_LM;

	if (isset($args->slug) && ($args->slug != $theme_base))	
		return false;

	$args->version 	= $theme_version;
	$request_string = prepare_request($action, $args);
	$request 		= wp_remote_post(MWP_MOBILE_THEME_UPDATER, $request_string);

	if (is_wp_error($request)) {
		$res = new WP_Error('themes_api_failed', 'An Unexpected HTTP Error occurred during the API request.</p> <p><a href="?" onclick="document.location.reload(); return false;">Try again</a>', $request->get_error_message());
	} else {
		$res = unserialize($request['body']);
		if ($res === false)
			$res = new WP_Error('themes_api_failed', 'An unknown error occurred', $request['body']);
	}
	return $res;
}


global $pagenow;
if ( $pagenow == 'themes.php' || $pagenow == 'update-core.php') {
	if ( $get_theme->exists() ) {
		add_filter('pre_set_site_transient_update_themes', 'mwp_mobile_check_for_update_lm');
		add_filter('themes_api', 'mwp_mobile_auto_update_call_lm', 10, 3);
	}
}

if (is_admin()) {
	$current = get_transient('update_themes');
}